
<?php
//
//  HSession.php
//

/*
 * session level
 */
define('HSLV_FOREVER', 0);

/*
 * variable name for regist to session
 */
define('HSESSION_VARIABLE_NAME', '_hsession_variables');

class HSession {

    // constructor
    function HSession() {
        session_start();
        session_register(HSESSION_VARIABLE_NAME);
    }

    function clear() {
        session_unregister(HSESSION_VARIABLE_NAME);
    }

    function destroy() {
        session_destroy();
    }

    function isAvail() {
        return session_is_registered(HSESSION_VARIABLE_NAME);
    }

    function setVar($name, $val, $level =HSLV_FOREVER) {
        $vars = HSESSION_VARIABLE_NAME;
        global $$vars;
        if (!isset($$vars))
            $$vars = array();
        ${$vars}[$name] = array($val, $level);
    }

    function getVar($name) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        list($val, $level) = ${$vars}[$name];
        return $val;
    }

    function getLevel($name) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        list($val, $level) = ${$vars}[$name];

        return $level;
    }

    function issetVar($name) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        return isset(${$vars}[$name]);
    }

    function unsetVar($name) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        unset(${$vars}[$name]);
    }

    function unsetAllAt($level) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        if (isset($$vars)){
            foreach ($$vars as $name => $pair) {
                list($val, $lv) = $pair;
                if ($lv == $level)
                HSession::unsetVar($name);
            }
        }
    }

    function unsetAllOver( $level ) {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        if (isset($$vars)) {
            foreach ($$vars as $name => $pair) {
                list($val, $lv) = $pair;
                if ($lv > $level)
                HSession::unsetVar( $name );
            }
        }
    }

    // for debugging
    function dump() {
        $vars = HSESSION_VARIABLE_NAME; 
        global $$vars;
        if (isset($$vars)) {
            foreach ($$vars as $name => $pair) {
                list($val, $lv) = $pair;
                echo "name: $name, val: $val, level: $lv<br>\n";
            }
        }
    }
}

?>